Knuth-Morris-Pratt algorithm


http://www.mathcs.emory.edu/~cheung/Courses/323/Syllabus/Text/Matching-KMP1.html
http://www.mathcs.emory.edu/~cheung/Courses/323/Syllabus/Text/Matching-KMP2.html
http://www.mathcs.emory.edu/~cheung/Courses/323/Syllabus/Text/Matching-KMP3.html
Suppose the red character in the input text is the first unmatched character:

         T = ???????????????????
         P =     aaabaaaxyz               
    
The first possible way that pattern P can be found in the text is starting here:

        T = ????aaab??????????           
        P =         aaab???????
    
  • In the above example, we can slide the pattern P 4 characters further down without missing a matching pattern !!!
proper suffix of a prefix (of the pattern P) is a tail portion of a prefix that is not equal to the entire prefix

Maximum overlap of a prefix:
    • Let pre be a prefix of the pattern P
    • MaxOverlap(pre) = the longest proper suffix that is equal to a prefix of pre
You cannot use the entire prefix to determine the maximum overlap
  • The Maximum Overlap must be a proper suffix (i.e., it must be a substring !!!)
MaxOverlap(pre) is never equal entire prefix pre !!!!  
  • If there is a mismatch at T[i] and P[j] (i.e., T[i] ≠ P[j]) and the MaxOverlap of the prefix has length k:

    Then we can slide P so that the suffix and prefix aligns without missing out on a match:


  • If the mismatched location is P[j], then prefix is:
      • P[0 .. (j−1)] !!!         
  • "Fast slide" algorithm on mismatch --- psuedo code:

              prefix = P[ 0..(j-1) ];    // Prefix of pattern at the mismatch    
      
       k = MaxOverlap( prefix );  // Compute max overlap
      
       j = k;
       i0 = (i - j);
       // i is unchanged !
      
      



  • Example:

                          1         2  
                01234567890123456789012          (ruler)             
               i0=0   i=7
         |      |
         v      v
             T: abadababaccabacabaabb
             P: abadabacb
                       ^
         |
         j=7
      
      
      Prefix: abadaba Maximum overlap: abadaba abadaba So: k = 3
      1 2 01234567890123456789012 (ruler) i0=0 i=7 | | v v T: abadababaccabacabaabb P: abadabacb ^ | j=7 Update: j = 3 (k = 3) i0 = (7-3) = 4 New situation: 1 2 01234567890123456789012 (ruler) i0=4 i=7 | | v v T: abadababaccabacabaabb P: abadabacb ^ | j=3
The KMP failure function (= the skip distance when there is a mismatch)
    • Let P   =   p0 p1 p2 ... pk ... pm-1

    • The failure function f(k) is defined as:

            f(k) = MaxOverlap( "p0 p1 p2 ... pk " )     
        
      which is the length of the longest suffix of "p1 p2 p3 ... pkthat is a prefix of p0 p1 p2 ... pk
      Graphically:

  • We must exclude the first character p0 because the maximum overlap must be a proper suffix
  • Example: computing the failure function

        Pattern:
      
          Position:    012345
          P:           abacab
      
      
      Prefix ending at pos k Max overlap f(k) ---------------------- --------------------- ------- k=1 ab (a)b ab 0 k=2 aba (a)ba aba 1 k=3 abac (a)bac abac 0 k=4 abaca (a)baca abaca 1 k=5 abacab (a)bacab abacab 2
      Failure function: i = | 0 | 1 | 2 | 3 | 4 | 5 | ----------+---+---+---+---+---+---+ f(i) = | 0 | 0 | 1 | 0 | 1 | 2 |
  • By default, we set:   f(0) = 0which will make the pattern P slide over 1 character position
Knuth–Morris–Pratt algorithm - Wikipedia
"Partial match" table (also known as "failure function")

We want to be able to look up, for each position in W, the length of the longest possible initial segment ofW leading up to (but not including) that position, other than the full segment starting at W[0] that just failed to match; this is how far we have to backtrack in finding the next match. Hence T[i] is exactly the length of the longest possible proper initial segment of W which is also a segment of the substring ending at W[i - 1]. We use the convention that the empty string has length 0. Since a mismatch at the very start of the pattern is a special case (there is no possibility of backtracking), we set T[0] = -1

i0123456
W[i]ABCDABD
T[i]-1000012
Another example, more interesting and complex:
i000102030405060708091011121314151617181920212223
W[i]PARTICIPATEINPARACHUTE
T[i]-100000001200000012300000
Failure Function
algorithm kmp_table:
    input:
        an array of characters, W (the word to be analyzed)
        an array of integers, T (the table to be filled)
    define variables:
        an integer, pos ← 2 (the current position we are computing in T)
        an integer, cnd ← 0 (the zero-based index in W of the next 
character of the current candidate substring)

    (the first few values are fixed but different from what the algorithm 
might suggest)
    let T[0] ← -1, T[1] ← 0

    while pos < length(W) do
        (first case: the substring continues)
        if W[pos - 1] = W[cnd] then
            let cnd ← cnd + 1, T[pos] ← cnd, pos ← pos + 1

        (second case: it doesn't, but we can fall back)
        else if cnd > 0 then
            let cnd ← T[cnd]

        (third case: we have run out of candidates.  Note cnd = 0)
        else
            let T[pos] ← 0, pos ← pos + 1
https://weblogs.java.net/blog/potty/archive/2012/05/10/string-searching-algorithms-part-ii
public int[] prekmp(String pattern) {
  int[] next = new int[pattern.length()];
  next[0] = -1;
  next[1] = 0;
  int pos = 2, cnd = 0;

  while (pos < pattern.length()) {
    if (pattern.charAt(pos - 1) == pattern.charAt(cnd)) {
      cnd++;
      next[pos] = cnd;
    } else {
      cnd = next[cnd];
      while (cnd > 0
          && pattern.charAt(pos - 1) != pattern.charAt(cnd))
        cnd = next[cnd];

      if (cnd < 0) {
        next[pos] = 0;
        cnd = 0;
      } else {
        next[pos] = cnd;
      }
    }

    pos++;
  }
  return next;
}

public int[] prekmpOpt(String pattern) {
  int[] next = new int[pattern.length()];
  int i = 0, j = -1;
  next[0] = -1;
  while (i < pattern.length() - 1) {
    while (j >= 0 && pattern.charAt(i) != pattern.charAt(j))
      j = next[j];
    i++;
    j++;
    next[i] = j;
  }
  return next;
}
  (5)
                        1
              01234567890123456789           (ruler)
            i=5
            |
            v
              abacaabaccabacabaabb
       abacab
            ^
            |
            j=5

       T[i=5] != P[j=5]    ==>   Don't change i
                                 Set j = f(4) = 1 !!!
                                 (Because matching prefix ended at pos 4 !!!)   

       Result:

                        1
              01234567890123456789           (ruler)
            i=5
            |
            v
              abacaabaccabacabaabb
           abacab
            ^
            |
            j=1

KMP Search:
algorithm kmp_search:
    input:
        an array of characters, S (the text to be searched)
        an array of characters, W (the word sought)

    define variables:
        an integer, m ← 0 (the beginning of the current match in S)
        an integer, i ← 0 (the position of the current character in W)
        an array of integers, T (the table, computed elsewhere)

    while m + i < length(S) do
        if W[i] = S[m + i] then
            if i = length(W) - 1 then
                return m
            let i ← i + 1
        else
            if T[i] > -1 then
                let m ← m + i - T[i], i ← T[i]
            else
                let i ← 0, m ← m + 1
            
    (if we reach here, we have searched all of S unsuccessfully)
    return the length of S

public int kmp(String text, String pattern) {
  int[] next = prekmp(pattern);
  int textStart = 0, patternStart = 0;
  while (textStart + patternStart < text.length()) {
    if (text.charAt(textStart + patternStart) == pattern
        .charAt(patternStart)) {
      if (patternStart == pattern.length() - 1) {
        return textStart;
      }
      patternStart++;
    } else {
      if (next[patternStart] > -1) {
        textStart = textStart + patternStart
            - next[patternStart];
        patternStart = next[patternStart];
      } else {
        textStart++;
        patternStart = 0;
      }
    }
  }
  return -1;
}

public int kmp2(String text, String pattern) {
  int[] next = prekmp(pattern);
  int i = 0, j = 0;
  while (i < text.length()) {
    while (j >= 0 && text.charAt(i) != pattern.charAt(j))
      j = next[j];
    i++;
    j++;
    if (j == pattern.length())
      return i - pattern.length();
  }
  return -1;
}

http://www.mathcs.emory.edu/~cheung/Courses/323/Syllabus/Text/Matching-KMP2.html
The values f(k) are computed easily using existing prefix overlap information:
    • f(0) = 0 (f(0) is always 0)
    • f(1) is computing using (already computed) value f(0)
    • f(2) is computing using (already computed) value f(0), f(1)
    • f(3) is computing using (already computed) value f(0), f(1), f(2)
    • And so on.
Relating f(k) to f(k−1)
  • According to the definition of f(k):


  • Suppose that we know that: f(k−1) = x
  • Can we use the fact that f(k−1) = x to compute f(k) ?
f(k)      f(k−1) + 1 
If px == pkthen:

       f(k) = x+1 
    
       (i.e., the maximum overlap of the prefix
    
                     p0   p1   p2 .... pk-1  pk    
    
         has x+1 characters 
We want to compute f(9) using f(8) but now the next character does not match:

                 0123456789
        prefix = ababyababa
    
                 ababyababa
        ababyababa  
    
        Conclusion:
    
           *** We CANNOT use f(8) to compute f(9) ***   
  • To find the maximum overlap, we must slide the prefix down and look for matching letters !!!
  • Let: f(k−1) = x(Note: f(k−1) is equal to some value. The above assumption simply gave a more convenient notation for this value).
    If px ≠ pkthen:

      • The next prefix that can be used to compute f(k) is:

               p0 p1 .... px-1        
          
    In pseudo code

          i = k-1;       // Try to use f(k-1) to compute f(k)
          x = f(i);    // x = character position to match against pk    
      
          if  ( P[k] == P[x] )  then     
      
              f(k) = f(x−1) + 1
      
          else
      
              Use:  p0 p1 .... px-1 to compute f(k)
      
              What that means in terms of program statements:
      
          i = x-1;    // Try to use f(x-1) to compute f(k) 
          x = f(i);   // x = character position to match against pk
      

  public static int[] KMP_failure_function(String P)
   {
      int k, i, x, m;
      int f[] = new int[P.length()];

      m = P.length();

      f[0] = 0;            // f(0) is always 0

      for ( k = 1; k < m; k++ )
      {
         // Compute f[k]

         i = k-1;           // First try to use f(k-1) to compute f(k)
         x = f[i];

         while ( P.charAt(x) != P.charAt(k) )
         {
            i = x-1;        // Try the next candidate f(.) to compute f(k)     

            if ( i < 0 )    // Make sure x is valid
               break;       // STOP the search !!!

            x = f[i];
         }


         if ( i < 0  )
            f[k] = 0;          // No overlap at all: max overlap = 0 characters
         else
            f[k] = f[i] + 1;   // We can compute f(k) using f(i)
      }

      return(f);
   }
http://www.mathcs.emory.edu/~cheung/Courses/323/Syllabus/Text/Matching-KMP3.html
  • In each iteration of the loopat least one of the variables:
      • i
      • i0          
    is increased by at least 1
  • Therefore:
      • You can increase i ≤ (i.e., at most) n times          and              
      • You can increase k ≤ (i.e., at most) n times


  • Because each time through the while loop, we will either:
      • increase i by (at least) 1        or           
      • increase i0 by (at least) 1
    the maximum # times that the loop can ever be executed is:


           # iteration2 × n              
      
    (Otherwise, we will increase one of the variables i or k by more than n !!!)
Running time of the KMP algorithm = O(n)
Also refer to Knuth–Morris–Pratt algorithm - Wikipedia
https://weblogs.java.net/blog/potty/archive/2012/05/10/string-searching-algorithms-part-ii
Java code:
http://www.sanfoundry.com/java-program-knuth-morris-pratt-algorithm/
http://algs4.cs.princeton.edu/53substring/KMP.java.html
http://www.fmi.uni-sofia.bg/fmi/logic/vboutchkova/sources/KMPMatch_java.html
http://algs4.cs.princeton.edu/53substring/KMPplus.java.html
http://tekmarathon.com/2013/05/14/algorithm-to-find-substring-in-a-string-kmp-algorithm/
Read full article from Knuth-Morris-Pratt algorithm

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts